#!BINDIR/pgoblin -f
  Copyright (C)2021..2022 @BABOLO http://www.babolo.ru/
  PKG = mini-cipa-dripa
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: sync.pgoblin.m4,v 1.12 2022/04/30 03:15:24 babolo Exp $

#connect 0001
CIPA_DBMS
GETARG(, 1, 1)
GETENV(, 1, 1)
#perform 0001
CREATE TEMP TABLE x(b text);
#perform 0001
INSERT INTO x
 SELECT COALESCE( (SELECT a FROM a WHERE i = 0 AND regexp('^[a-z0-9_]+$', a))
                , 'minicipa'
                )
;
#select  1001
SELECT 'pgsql dbname=' || b || ' requirepeer=postgres application_name=minicipa'
 FROM x
;
#connect 0102
#close   101
#select  0002
SELECT '*****  Illegal user ', current_user, ' must be postgres  *****
'WHERE current_user::text IS DISTINCT FROM 'postgres'
;
#select  1002
SELECT '#exit
'WHERE current_user::text IS DISTINCT FROM 'postgres'
;
#eval    01
#close   101
#select  1002  ###################################################  CREATE ROLE rNNN WITH NOLOGIN  ####
SELECT
 'CREATE ROLE r' || credent::text || ' NOLOGIN INHERIT;
'FROM gate
  LEFT JOIN pg_roles ON('r' || gate.credent::text = pg_roles.rolname::text)
 WHERE rolname IS NULL
;
#perform 0102
#select  1002  ###############################################################  GRANT rNNN TO www  ####
SELECT
 'GRANT r' || credent::text || ' TO www;
'FROM gate
;
#perform 0102
#select  1002  ##################################################################  DROP ROLE rNNN  ####
SELECT
 'DROP ROLE ' || pg_roles.rolname::text || ';
'FROM pg_roles
  LEFT JOIN gate ON('r' || gate.credent::text = pg_roles.rolname::text)
 WHERE credent IS NULL
   AND pg_roles.rolname::text ~ '^r[0-9]+$'
;
#perform 0102
#perform 0002
UPDATE public.cipato SET plan = now() FROM public.sync WHERE (cipato.m, cipato.v) = (sync.m, sync.v);
#perform 0002  ##################################################  setval('gate_q', MAX(credent))  ####
SELECT setval('gate_q', MAX(credent)) FROM gate;
#close   1011
#close   1012
